Make `for_window[floating|tiling]` when floating status is updated
I don’t see a link to logs.i3wm.org. Did you follow https://i3wm.org/docs/debugging.html? (In case you actually provided a link to a logfile, please ignore me.)
Hi,

logically speaking the conditions would have to be reversed:

    for_window [floating] [title="myterminal"] resize set 800 600

However, this won't work because `for_window` executes only for new windows, not when you float a window later on. To achieve this I think you'll need to utilize the IPC i3 offers.

I'm also closing this since it's not a bug or feature request. For getting help we'd recommend you take a look at the /r/i3wm subreddit where there's an entire community to help. Thanks :-)
`for_window` works for changes to class, title etc, not only for new windows:

https://github.com/i3/i3/blob/5aa0459be0a8471226dabda620c028c149966b29/src/window.c#L59
Ah, righ… my bad. I was somehow mixing it up with assign. I'm getting i3-old. :-)
@orestisf1993 does that mean my use case is achievable without using IPC?
The correct syntax for what you are trying to achieve would be: `for_window [title="myterminal" floating] resize set 800 600` but it doesn't work because we don't check for `for_window` rules after changing floating status for a window. So, technically, this is a bug.

@Airblader should we fix this?
I don't think that's the syntax he's looking for because he wants to do something with the terminal whenever *any* window is floated — at least that's how I understood it.
Ah, yes, this seems to be the case.

Either way, the usecase for my directive is still not possible through for_window.
Sorry I wasn't very clear in the issue description. I want a (specific) window to be resized when it enters floating mode. I mentioned the terminal because that's mainly where I want this behaviour to occur
@Airblader I have a solution for this but it might introduce backward incompatibilities for people that have something like `for_window[floating] floating disable` in their config
Can you elaborate on that?
Well, the bug here is that when enabling floating for a window, `for_window [floating]` should be trigger; the same happens e.g. for `for_window[class=…]` rules. But some people could depend on this bug for example to disable floating for all windows once they open like with `for_window[floating] floating disable` or similar.

Solution here https://github.com/i3/i3/compare/next...orestisfl:A_I3_FLOATING_WINDOW. The obvious solution of `run_assignments` after `floating_{enable,disable}` doesn't work because `run_assignments` modifies the parser state in https://github.com/i3/i3/blob/6011e245e98616706ceceaa471d2908e6213fa39/src/assignments.c#L51
I'm not sure I follow that yet. If we currently do not trigger the assignments on floating change then `for_window [floating] floating disable` doesn't work currently, no?
It works for windows that start as floating, eg `GtkFileChooserDialog`

https://github.com/i3/i3/blob/6011e245e98616706ceceaa471d2908e6213fa39/src/manage.c#L449-L460
I see. Hm, that could be an issue indeed. At the same time it's more consistent to trigger assignments on changes as well since we do it for other criteria.

@stapelberg Do you have an opinion?
Could we get around the change in behavior by extending the “floating” criterion to allow specifying which kind of trigger for floating (e.g. FLOATING_AUTO_ON vs. FLOATING_USER_ON) was used?

Then, the use-case asked for in this issue could be covered by only triggering on user-triggered changes, whereas the default could be that “floating” without an argument means auto-floating.
So we have:

1. `for_window[tiling]` = `for_window[tiling=auto]`
2. `for_window[tiling=user]`
3. `for_window [floating]` = `for_window[floating=auto]`
4. `for_window[floating=user]`
This would break the following (legit) usecase:
```
for_window [class=URxvt] floating enable
for_window [floating] mark a
```
on the other hand, it provides more power to the users so I think it's worth it.

A solution that doesn't introduce this problem would be:
1. `for_window[tiling]` = tiling auto || user
2. `for_window[tiling=auto]`
3. `for_window[tiling=user]`
4. `for_window[floating]` = floating auto || user
6. `for_window[floating=auto]`
6. `for_window[floating=user]`
Yeah, you’re right: the default should be floating auto || user.

Your solution of triggering a run_assignments call via subscribing i3 to events generated by i3 is a neat idea, by the way :D 

The more tedious but a little bit cleaner solution would be to make the parser re-entrant so that we can actually nest parser usages like this.

I’m okay with either solution.
Hmm, after some effort I don't think I can make the parser to work with an optional `cvalue` here: https://github.com/i3/i3/blob/428cb94e29f32d7e1f064968bb94b65bf493d606/parser-specs/config.spec#L193-L204

Is there any way? A workaround is to extend using syntax like `floating_auto`, `floating_user` and `floating`.
> Yeah, you’re right: the default should be floating auto || user.

But this would still introduce the behavioral change mentioned in https://github.com/i3/i3/issues/3588#issuecomment-543130883 (eg `for_window[floating] floating disable`).

I think we can't win here and just go through with it and notify users about the change that they'll need to do in their config files in the off chance that they rely on the buggy behavior.
> Hmm, after some effort I don't think I can make the parser to work with an optional `cvalue` here:

Does it not work to introduce a new state, say FLOATING_CRITERION, which takes either '=' followed by a cvalue, or end?

> But this would still introduce the behavioral change mentioned in [#3588 (comment)](https://github.com/i3/i3/issues/3588#issuecomment-543130883) (eg `for_window[floating] floating disable`).

Yeah. As you mentioned, we have to break one or the other use-case, and since this one includes relying on buggy behavior, I think it’s better to break this one.
> Does it not work to introduce a new state, say FLOATING_CRITERION, which takes either '=' followed by a cvalue, or end?

`end` means end of line: https://github.com/i3/i3/blob/733077822302d8b77eacb606a26fd002a42f534f/src/config_parser.c#L407-L409
Ah, you can tell it’s been a while since I have touched this :)

Well, then not `end`, but the possible separator characters?
> Is there any way? A workaround is to extend using syntax like `floating_auto`, `floating_user` and `floating`.

The fix was easy after all, instead of `floating_auto` we can match for `floating=auto`.
Thinking about it again, it might be a pitfall to do it this way (eg `[tiling="auto"]` needs to also be supported). I'll go with `floating_auto` and `floating_user` again.